HDU 1081 To The Max--DP--(最大子矩阵)

题意:输入一个二维数组,求和最大的子矩阵

分析:一看到和最大的子XX,我就联想到和最大子序列,只不过那是一维这是二维,所以做法都差不多。把二维压缩成一维:你想啊一个矩阵的和不是可以先垂直方向相加把所有行压缩为一行然后这一行相加嘛。压缩过后找最大和的方法跟一维一模一样。但我自己做的时候写了四个循环,唉.....数组可以存放之前求过的和,那么求以下一行为结尾的和的时候只要在原来的数组上加这一行的数就行了,不需要从头循环求和!

dp[k]=a[i][k]+.....+a[j][k] 第 k 列第 i 行加到 j 行的和,起点 i、终点 j 要枚举遍历的,需要两个循环;k列也要一个循环,但是不需要一个循环每次for(int p=i;p<=j;p++)了,因为可以用前面已经加过的和

代码:

#include<iostream>
#include<cstring>
#define INF 1000000009
using namespace std;
int n,a[200][200],dp[200];
int ans,sum;
int main()
{
	while(cin>>n){
		for(int i=0;i<n;i++)
		for(int j=0;j<n;j++) cin>>a[i][j];
		ans=-INF;
		for(int i=0;i<n;i++){
			memset(dp,0,sizeof(dp));
			for(int j=i;j<n;j++){
				sum=-1;
				for(int k=0;k<n;k++){
					dp[k]+=a[j][k];
				}
				for(int k=0;k<n;k++){
					if(sum<0) sum=dp[k];
					else sum+=dp[k];
					if(ans<sum) ans=sum;
				}
			}
		}
		cout<<ans<<endl;
	}
}
时间: 2024-10-19 03:09:22

HDU 1081 To The Max--DP--(最大子矩阵)的相关文章

HDU 1081 To The Max(DP)

题意  求一个n*n矩阵的最大子矩阵和 HDU 1003 max sum 的升级版   把二维简化为一维就可以用1003的方法去做了  用mat[i][j]存  第i行前j个数的和   那么mat[k][j]-mat[k][i]就表示第k行  第i+1个数到第j个数的和了   再将k从一枚举到n就可以得到这个这个宽度为j-i的最大矩阵和了   然后i,j又分别从1枚举到n就能得到结果了   和1003的方法一样  只是多了两层循环 #include<cstdio> #include<cs

hdu 1081 To The Max 【最大子矩阵和】

To The Max Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 8882 Accepted Submission(s): 4288 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is

hdu 1081 To The Max(dp+化二维为一维)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1081 To The Max Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 8839    Accepted Submission(s): 4281 Problem Description Given a two-dimensional ar

HDU 1081 to the max 基础DP 好题

To The Max Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements

HDU 1081 To the Max 最大子矩阵(动态规划求最大连续子序列和)

Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1*1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in that rectangle. I

HDU 1081 To The Max 暴力模拟O(n^4) dp优化O(n^3)

原题: http://acm.hdu.edu.cn/showproblem.php?pid=1081 题目大意: 求给定边长的正方形选一个矩形,使它包含的所有元素的值最大. 大家都知道(a+b)^2的展开式,这里的优化就是用了这个原理来做的优化,我们的dp值是我们前i行j列的矩形区域的值. 任意矩形区域的值通过该展开式也能求解,所以我们可以暴力枚举每种以左上角(k,l)到右下角(i,j)的情况. 对于这个题边长是100,4层循环是10^8,因为循环并跑不了这么多,刚好也能卡过去. 代码如下: #

HDU 1081 To The Max

题目链接 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in th

hdu 1081 To The Max(最大连续子序列推广到二维)

#include<cstdio> #include<cstring> #include<algorithm> using namespace std; const int INF=1<<30; int a[105][105]; int b[105]; int dp[105]; int maxx,ans; int main() { int n; while(scanf("%d",&n)==1) { for(int i=1;i<

hdu 1081最大子矩阵的和DP

To The Max Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 8210    Accepted Submission(s): 3991 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectan

hdu 1081 &amp; poj 1050 To The Max(最大和的子矩阵)

转载请注明出处:http://blog.csdn.net/u012860063 Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1*1 or greater located within the whole array. The sum of a rectangle is the sum